#ifndef __TRSMT
#define __TRSMT

#include <windows.h>
#include <time.h>

#define SM_CONFIG       0
#define SM_ERROR        1
#define SM_FAULT        2

#define SA_GETCOUNT     -1

enum Status {NORMAL, BEACONING, RECOVERY, REMOVED}; //ring statuses

typedef char NameType[13];

typedef struct {
	NameType szAdapterAddress;      //adapter address
	NameType szAdapterName;         //adapter name
	NameType szNaunAddress;         //its NAUN's address
	NameType szNaunName;            //its NAUN's name
	NameType szFaultNaunAddress;    //its hard error fault domain NAUN's address
	NameType szFaultNaunName;       //its hard error fault domain NAUN's anme
	NameType szErrorNaunAddress;    //its soft error fault domain NAUN's address
	NameType szErrorNaunName;       //its soft error fault domain NAUN's name
	unsigned nBeaconType;           //beacon type
	unsigned nErrorCount[10];       //soft error counters
	time_t FaultTime;               //time at which hard error occurred
	time_t ErrorTime;               //time at which soft error occurred
} AdapterDetails;

	

#if __cplusplus
extern "C" {
#endif

void ReadConfig(void);
void SaveConfig(void);
BYTE Poll(enum Status *pStatus);
int GetAdapterInfo(int idInfo, int id, char *szLine);
int ChangeAdapterName(char *szAdapter, char *szName);
int GetAdapterDetails(char *szAdapter, AdapterDetails *pDetails);
int ResetInfo(int id);
BYTE RemoveIt(char *szAdapter);
BYTE ResetIt(void);
BYTE ActivateIt(BOOL *bEmulate);
BYTE InactivateIt(void);
BOOL TRAGNInstalled(void);
char * _ctime(const time_t * time);

#if __cplusplus
}
#endif

#endif

