#include <stdio.h>
#include <stdlib.h>
#include <dos.h>

#include "dlcptbls.h"
#include "dlcconst.h"
#include "trutl.h"


#define  TRNINT         0x5C	//token ring API software interrupt number

/* issues a token ring command without waiting for completion */
TRNcmd(unsigned char *cmdptr)
{
	union REGS inregs, outregs;
	struct SREGS segregs;
	
	segread(&segregs);
	segregs.es  = FP_SEG(cmdptr);
	inregs.x.bx = FP_OFF(cmdptr);
	
	return( int86x( TRNINT, &inregs, &outregs, &segregs));
}
	

/* checks if the token ring API has been installed */
Installed(unsigned char adapternum)
{
	unsigned long *int5cptr;
	CCB ccb;
	
	
	int5cptr = MK_FP(0, TRNINT * 4);

	if (!*int5cptr)
		return 0;               /* nothing to handle int 5C */

        memset( &ccb, 0, sizeof(CCB) );
        ccb.command  = DIR_INTERRUPT;
        ccb.retcode  = 0x42;		/* non-existent return code */
        ccb.adapter  = adapternum;
        ccb.parm_tab = ccb.pointer = ccb.cmd_cplt = ZEROADDRESS;
        
        TRNcmd((unsigned char *) &ccb);
        
        if (ccb.retcode == 0x42)
                return 0;               /* invalid return code */
        else
	return 1;

}


/* sends a MAC frame to remove the specified adapter */
RemoveStn(BYTE adapternum, WORD stationid, BYTE *adapter)
{
	static XMIT_BUFFER *header;
	static XMIT_BUFFER *vector;
	static BYTE buffer[sizeof(XMIT_BUFFER) * 2 + 35];
	CCB ccb;

	if (header == NULL)
	   {
	   memset((void *) buffer, 0, sizeof(buffer));
	   header = (XMIT_BUFFER *) &buffer[0];
	   vector = (XMIT_BUFFER *) &buffer[sizeof(XMIT_BUFFER) + 32];
	   header->next_buf_ptr = (BUFFER *) vector;
	   header->len_in_buffer = 14;
	   header->data[0] = 0x10;              //AC
	   header->data[1] = 0x01;              //FC

	   vector->len_in_buffer = 4;           //remove station
	   vector->data[1] = 0x04;
	   vector->data[2] = 0x04;
	   vector->data[3] = 0x0b;
	   }

	memcpy(&header->data[2], adapter, 6);   //Dest. address
	dir_transmit(&ccb, adapternum, stationid, header);
	BusyWait(ccb.retcode);
	return ccb.retcode;
}

